import { __decorate, __param } from 'tslib';
import { ɵɵdefineInjectable, ɵɵinject, Injectable, Inject, Component, EventEmitter, ViewChild, Output, Input, NgModule } from '@angular/core';
import { ToastrService, ToastrModule } from 'ngx-toastr';
import { MAT_DIALOG_DATA, MatDialogRef, MatDialog, MatDialogModule } from '@angular/material/dialog';
import { CommonModule } from '@angular/common';
import { ImageCropperModule } from 'ngx-image-cropper';
import { A11yModule } from '@angular/cdk/a11y';
import { ClipboardModule } from '@angular/cdk/clipboard';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatBadgeModule } from '@angular/material/badge';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatStepperModule } from '@angular/material/stepper';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatDividerModule } from '@angular/material/divider';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatMenuModule } from '@angular/material/menu';
import { MatNativeDateModule, MatRippleModule } from '@angular/material/core';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatSliderModule } from '@angular/material/slider';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatSortModule } from '@angular/material/sort';
import { MatTableModule } from '@angular/material/table';
import { MatTabsModule } from '@angular/material/tabs';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

let AlertService = class AlertService {
    constructor(toastr) {
        this.toastr = toastr;
    }
    showSuccess(message, title) {
        this.toastr.success(message, title);
    }
    showError(message, title) {
        this.toastr.error(message, title);
    }
    showInfo(message, title) {
        this.toastr.info(message, title);
    }
    showWarning(message, title) {
        this.toastr.warning(message, title);
    }
};
AlertService.ctorParameters = () => [
    { type: ToastrService }
];
AlertService.ɵprov = ɵɵdefineInjectable({ factory: function AlertService_Factory() { return new AlertService(ɵɵinject(ToastrService)); }, token: AlertService, providedIn: "root" });
AlertService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AlertService);

let MatConfirmDialogComponent = class MatConfirmDialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
    }
    ngOnInit() {
    }
    closeDialog() {
        this.dialogRef.close(false);
    }
};
MatConfirmDialogComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] },
    { type: MatDialogRef }
];
MatConfirmDialogComponent = __decorate([
    Component({
        selector: 'app-mat-confirm-dialog',
        template: "<h2 mat-dialog-title>Attention</h2>\r\n<mat-dialog-content class=\"mat-typography\">\r\n  <p [innerHTML]=\"data.message\"></p> \r\n</mat-dialog-content>\r\n<mat-dialog-actions >\r\n  <button mat-button color=\"warn\" id=\"yes-button\" [mat-dialog-close]=\"true\">{{data.ConfirmYes}}</button>\r\n  <button mat-button id=\"no-button\" [mat-dialog-close]=\"false\">{{data.ConfirmNo}}</button>\r\n</mat-dialog-actions>\r\n",
        styles: [".mat-dialog-container{transform:none;display:flex;justify-content:center;align-items:center;position:fixed;z-index:999;top:0;left:0;width:100vw;height:100vh;background:rgba(12,6,6,.44);align-items:center;margin:95px 0 0}"]
    }),
    __param(0, Inject(MAT_DIALOG_DATA))
], MatConfirmDialogComponent);

let DialogService = class DialogService {
    constructor(dialog) {
        this.dialog = dialog;
    }
    openConfirmDialog(msg) {
        return this.dialog.open(MatConfirmDialogComponent, {
            width: '390px',
            panelClass: 'confirm-dialog-container',
            disableClose: true,
            position: { top: "10px" },
            data: {
                message: msg,
                ConfirmYes: 'Yes',
                ConfirmNo: 'No'
            }
        });
    }
    popup(msg) {
        return this.dialog.open(MatConfirmDialogComponent, {
            width: '390px',
            panelClass: 'confirm-dialog-container',
            disableClose: true,
            position: { top: "10px" },
            data: {
                message: msg,
                ConfirmNo: 'Ok'
            }
        });
    }
};
DialogService.ctorParameters = () => [
    { type: MatDialog }
];
DialogService.ɵprov = ɵɵdefineInjectable({ factory: function DialogService_Factory() { return new DialogService(ɵɵinject(MatDialog)); }, token: DialogService, providedIn: "root" });
DialogService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], DialogService);

let NgImageCropperComponent = class NgImageCropperComponent {
    constructor(alertService, dialog, dialogRef, data) {
        this.alertService = alertService;
        this.dialog = dialog;
        this.dialogRef = dialogRef;
        this.data = data;
        this.imageChangedEvent = '';
        this.croppedImage = '';
        this.loading = true;
    }
    ngOnInit() {
        this.imageChangedEvent = this.data;
    }
    imageCropped(event) {
        this.croppedImage = event.base64;
    }
    imageLoaded() {
        //this.loading = false;
    }
    cropperReady() {
        this.loading = false;
    }
    loadImageFailed() {
        this.alertService.showError("", "OOps!! unable to load image.");
        this.loading = false;
    }
    crop() {
        let imageDetails = {
            Image: new File([this.croppedImage], this.data.target.files[0].name),
            name: this.data.target.files[0].name,
            type: this.data.target.files[0].type,
            base64: this.croppedImage
        };
        this.dialogRef.close({ event: 'crop', data: imageDetails });
    }
    closeDialog() {
        this.dialogRef.close({ event: 'close', data: null });
    }
};
NgImageCropperComponent.ctorParameters = () => [
    { type: AlertService },
    { type: MatDialog },
    { type: MatDialogRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
];
NgImageCropperComponent = __decorate([
    Component({
        selector: 'app-ng-image-cropper',
        template: "<mat-dialog-content>\r\n    <div class=\"mat-loading\" *ngIf=\"loading\">\r\n        <mat-spinner></mat-spinner>\r\n    </div>\r\n    <div class=\"img-section\">\r\n        <image-cropper class=\"img-section\" [imageChangedEvent]=\"imageChangedEvent\" [maintainAspectRatio]=\"true\"\r\n            [aspectRatio]=\"4 / 3\" format=\"png\" (imageCropped)=\"imageCropped($event)\" (imageLoaded)=\"imageLoaded()\"\r\n            (cropperReady)=\"cropperReady()\" (loadImageFailed)=\"loadImageFailed()\"></image-cropper>\r\n    </div>\r\n\r\n</mat-dialog-content>\r\n<mat-dialog-actions class=\"mat-action\">\r\n    <div class=\"btn-wrapper\">\r\n        <div class=\"mat-btn\">\r\n            <button mat-flat-button (click)=\"crop()\" color=\"primary\">Crop</button>\r\n            <button mat-button (click)=\"closeDialog()\">Cancel</button>\r\n        </div>\r\n    </div>\r\n</mat-dialog-actions>",
        providers: [DialogService, AlertService],
        styles: ["mat-dialog-actions{float:right}.img-section{margin:20px;display:flex;max-width:445px;max-height:302px;padding:25px;align-items:center}.mat-loading{display:flex;position:relative;padding:140px;margin:0 0 0 50px}"]
    }),
    __param(3, Inject(MAT_DIALOG_DATA))
], NgImageCropperComponent);

let ImageUploaderComponent = class ImageUploaderComponent {
    constructor(dialog, alertService, dialogService) {
        this.dialog = dialog;
        this.alertService = alertService;
        this.dialogService = dialogService;
        this.urlsDetails = [];
        this.imageDetails = new EventEmitter();
        this.allowImageType = [];
        if (this.allowImageType.length == 0) {
            this.allowImageType = ["jpg", "jpeg", "png"];
        }
        if (this.sizeLimit == 0 || this.sizeLimit < 0 || typeof (this.sizeLimit) == "undefined") {
            this.sizeLimit = 5;
        }
    }
    ngOnInit() {
    }
    UploadFile(files) {
        let imgae = files.target.files[0];
        let IsValidUpload = false;
        let StatusMessage;
        const allowedExtensions = this.allowImageType;
        const fileItem = imgae.size / 1024 / 1024;
        const FileExt = imgae.type.split("/")[1];
        const fileType = imgae.type.split("/")[0];
        for (let i = 0; i < allowedExtensions.length; i++) {
            if (FileExt === allowedExtensions[i].trim()) {
                IsValidUpload = true;
                if (fileItem > this.sizeLimit) {
                    StatusMessage = "File size should be less than " + this.sizeLimit + " MB.";
                    IsValidUpload = false;
                }
                if (fileType != "image") {
                    StatusMessage = "Oops! Only image files are allowed.";
                    IsValidUpload = false;
                }
                break;
            }
            else {
                StatusMessage = "Oops!! Only " + this.allowImageType.toString() + " images are allowed.";
                IsValidUpload = false;
            }
        }
        if (IsValidUpload === false) {
            this.alertService.showWarning("", StatusMessage);
        }
        else {
            if (this.Iscrop) {
                const dialogRef = this.dialog.open(NgImageCropperComponent, {
                    width: "590px",
                    height: "484px",
                    data: files,
                    disableClose: true
                });
                dialogRef.afterClosed().subscribe(result => {
                    if (result.event != 'close') {
                        this.urlsDetails.push({
                            Url: result.data.base64,
                            DisplayName: result.data.name,
                            OriginalImage: result.data.Image
                        });
                        this.imageDetails.emit(this.urlsDetails);
                    }
                    else {
                        this.uploadInput.nativeElement.value = '';
                    }
                });
            }
            else {
                const reader = new FileReader();
                reader.onload = (e) => {
                    e.stopPropagation();
                    this.urlsDetails.push({
                        Url: e.target.result,
                        DisplayName: imgae.name,
                        OriginalImage: imgae
                    });
                };
                reader.readAsDataURL(imgae);
                this.imageDetails.emit(this.urlsDetails);
            }
        }
    }
    dropFiles(event) {
        if (event.dataTransfer) {
            if (event.dataTransfer.types[0] === "Files") {
                let inputMarkup = {
                    target: {
                        files: event.dataTransfer.files
                    }
                };
                this.UploadFile(inputMarkup);
            }
            else {
                this.alertService.showError("", "OOps!! something goes wrong");
                return;
            }
        }
    }
    ondragover(event) {
        event.stopPropagation();
        event.preventDefault();
    }
    ondrop(event) {
        event.stopPropagation();
        event.preventDefault();
        this.dropFiles(event);
    }
    onDeleteCall(name, index) {
        this.dialogService
            .openConfirmDialog("Are you sure you want delete this image?").afterClosed()
            .subscribe(res => {
            if (res) {
                if (index !== -1) {
                    this.uploadInput.nativeElement.value = '';
                    this.urlsDetails.splice(index, 1);
                    this.imageDetails.emit(this.urlsDetails);
                }
            }
        });
    }
};
ImageUploaderComponent.ctorParameters = () => [
    { type: MatDialog },
    { type: AlertService },
    { type: DialogService }
];
__decorate([
    ViewChild("uploader")
], ImageUploaderComponent.prototype, "uploadInput", void 0);
__decorate([
    Output()
], ImageUploaderComponent.prototype, "imageDetails", void 0);
__decorate([
    Input()
], ImageUploaderComponent.prototype, "allowImageType", void 0);
__decorate([
    Input()
], ImageUploaderComponent.prototype, "sizeLimit", void 0);
__decorate([
    Input()
], ImageUploaderComponent.prototype, "Iscrop", void 0);
ImageUploaderComponent = __decorate([
    Component({
        selector: 'app-angular-material-uploader',
        template: "<div class=\"page-content\">\r\n    <div fxLayout=\"column\" fxLayoutGap=\"15px\" fxLayout.gt-md=\"row\" fxLayoutGap.gt-md=\"30px\">\r\n        <div fxFlex=\"40\" class=\"wrapper\">\r\n            <div class=\"card\">\r\n                <div class=\"card-body\">\r\n                    <h5 class=\"card-title mb-3\">Photos & Videos</h5>\r\n                    <div class=\"fileuploader fileuploader-theme-dragdrop\">\r\n                        <input id=\"input-file\" type=\"file\" #uploader (change)=\"UploadFile($event)\" class=\"cdk-visually-hidden\" />\r\n                        <label for=\"input-file\" class=\"fileuploader-input\" (dragover)=\"ondragover($event)\"\r\n                            (drop)=\"ondrop($event)\">\r\n                            <div class=\"fileuploader-input-inner\">\r\n                                <div class=\"fileuploader-main-icon\"></div>\r\n                                <h5 class=\"fileuploader-input-caption\">\r\n                                    Drop files here to upload\r\n                                </h5>\r\n                                <p>or</p>\r\n                                <div class=\"fileuploader-input-button\" matRipple>\r\n                                    <span>Browse files</span>\r\n                                </div>\r\n                            </div>\r\n                        </label>\r\n\r\n                        <!--//.fileuploader-input-->\r\n                        <div class=\"fileuploader-items\">\r\n                            <div class=\"fileuploader-items-list\" *ngFor=\"let item of urlsDetails; let i = index\">\r\n                              <div class=\"fileuploader-item file-has-popup file-type-image file-ext-png\">\r\n                                <div class=\"columns\">\r\n                                  <div class=\"columns-thumbnail\">\r\n                                    <div class=\"fileuploader-item-image\">\r\n                                      <img [src]=\"item.Url\" />                                  \r\n                                    </div>\r\n                                  </div>\r\n                                  <div class=\"column-title\">\r\n                                    <h5>{{ item.DisplayName }}</h5>\r\n                                  </div>\r\n                                  <div class=\"columns-actions\">\r\n                                    <button type=\"button\" mat-icon-button matTooltip=\"Delete\" matTooltipPosition=\"above\"\r\n                                      (click)=\"onDeleteCall(item.DisplayName,i)\">\r\n                                      <mat-icon>remove_circle</mat-icon>\r\n                                    </button>\r\n                                  </div>\r\n                                </div>\r\n                                <!--//.columns-->\r\n                              </div>\r\n                              <!--//.fileuploader-item-->\r\n                            </div>\r\n                            <!--//.fileuploader-items-list-->\r\n                          </div>\r\n                        <!--//.fileuploader-items-->\r\n                        <div class=\"fileuploader-info\">\r\n                            Image specifications\r\n                            <mat-icon\r\n                                matTooltip=\"Image must be less than {{sizeLimit}} mb. Allowed file types : {{allowImageType}}.\"\r\n                                matTooltipPosition=\"after\" class=\"help\">error_outline</mat-icon>\r\n                        </div>\r\n                        <!--//.fileuploader-info-->\r\n                    </div>\r\n                    <!--//.fileuploader-->\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
        providers: [DialogService],
        styles: [".form-stacked{display:flex;flex-direction:column}.form-stacked .mat-form-field{display:block}.card{border-color:#ededed;position:relative;display:flex;flex-direction:column;min-width:0;word-wrap:break-word;background-color:#fff;background-clip:border-box;border:1px solid rgba(0,0,0,.125);border-radius:.25rem}.card-title{font-size:16px;font-weight:500}.card .action{top:10px;right:10px;position:absolute}.card:hover .mat-icon-button{opacity:1}.card-header{font-weight:500;font-size:1.1428571rem}.card-header.has-action{padding-top:16px}.card-header.has-action .card-title{text-overflow:ellipsis;white-space:nowrap;overflow:hidden;padding-right:30px;padding-left:30px;display:block}.card-body{flex:1 1 auto;padding:1.25rem}.fileuploader-theme-dragdrop .fileuploader-input{border:2px dashed #c3e2c7;border-radius:.25rem;position:relative;display:flex;justify-content:center;align-items:center;padding:3rem 1rem;text-align:center}.fileuploader-theme-dragdrop .fileuploader-input-caption{border:0!important;margin:0!important}.fileuploader-theme-dragdrop p{color:#e2d1d1a6}.fileuploader-input{margin-bottom:0;display:flex}.fileuploader-input-button{border-radius:.25rem;margin-bottom:0;padding:0 1rem;cursor:pointer}.fileuploader-items{display:flex;flex-wrap:wrap;flex-direction:column}.fileuploader-item-image{border-radius:4px;padding:3px;border:1px solid #ededed;display:flex;justify-content:center;align-items:center;height:100%}.fileuploader-item-image img{max-width:100%;max-height:100%}.fileuploader-items-list{border-bottom:1px solid #ededed}.fileuploader-items .fileuploader-item .columns{display:flex;flex-wrap:wrap;align-items:center;padding:10px 0}.fileuploader-items .fileuploader-item .columns-thumbnail{height:64px;width:64px}.fileuploader-items .fileuploader-item .column-title{margin-left:1rem;margin-right:1rem;flex:1}.fileuploader-items .fileuploader-item .column-title h5{font-size:1rem;font-weight:400;color:#484848;word-wrap:anywhere;word-break:break-all}.fileuploader-items .fileuploader-item .columns-actions .mat-icon-button{color:#f16e69}.fileuploader-info{display:flex;align-items:center;justify-content:center;padding:1rem 0 0;color:#959595}.fileuploader-info .mat-icon{margin-left:.5rem}.fileuploader-input .fileuploader-input-caption{position:relative;display:inline-block;flex:1;align-self:flex-start;padding:0 16px;line-height:36px;background:#fff;border:1px solid #ebeef1;border-radius:.25rem;box-shadow:0 4px 18px rgba(0,0,0,.01);white-space:nowrap;text-overflow:ellipsis;overflow:hidden;margin-right:10px;color:#e2d1d1a6;font-weight:400}.fileuploader-input .fileuploader-input-button{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;background:#34b34f;color:#fff;box-shadow:0 4px 18px rgba(0,0,0,.04);white-space:nowrap;line-height:36px;display:inline-block}.fileuploader-input-caption{font-size:1.25rem}.wrapper{text-align:center;padding:0;margin:135px auto}"]
    })
], ImageUploaderComponent);

let MaterialModule = class MaterialModule {
};
MaterialModule = __decorate([
    NgModule({
        exports: [
            A11yModule,
            ClipboardModule,
            CdkStepperModule,
            CdkTableModule,
            CdkTreeModule,
            DragDropModule,
            MatAutocompleteModule,
            MatBadgeModule,
            MatBottomSheetModule,
            MatButtonModule,
            MatButtonToggleModule,
            MatCardModule,
            MatCheckboxModule,
            MatChipsModule,
            MatStepperModule,
            MatDatepickerModule,
            MatDialogModule,
            MatDividerModule,
            MatExpansionModule,
            MatGridListModule,
            MatIconModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatNativeDateModule,
            MatPaginatorModule,
            MatProgressBarModule,
            MatProgressSpinnerModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSliderModule,
            MatSlideToggleModule,
            MatSnackBarModule,
            MatSortModule,
            MatTableModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatTreeModule,
            PortalModule,
            ScrollingModule
        ],
        imports: [
            A11yModule,
            ClipboardModule,
            CdkStepperModule,
            CdkTableModule,
            CdkTreeModule,
            DragDropModule,
            MatAutocompleteModule,
            MatBadgeModule,
            MatBottomSheetModule,
            MatButtonModule,
            MatButtonToggleModule,
            MatCardModule,
            MatCheckboxModule,
            MatChipsModule,
            MatStepperModule,
            MatDatepickerModule,
            MatDialogModule,
            MatDividerModule,
            MatExpansionModule,
            MatGridListModule,
            MatIconModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatNativeDateModule,
            MatPaginatorModule,
            MatProgressBarModule,
            MatProgressSpinnerModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSliderModule,
            MatSlideToggleModule,
            MatSnackBarModule,
            MatSortModule,
            MatTableModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatTreeModule,
            PortalModule,
            ScrollingModule
        ]
    })
], MaterialModule);

let AngularMaterialUploaderModule = class AngularMaterialUploaderModule {
};
AngularMaterialUploaderModule = __decorate([
    NgModule({
        declarations: [ImageUploaderComponent, NgImageCropperComponent, MatConfirmDialogComponent],
        imports: [
            CommonModule,
            ImageCropperModule,
            MaterialModule,
            FormsModule,
            ReactiveFormsModule,
            FlexLayoutModule,
            BrowserAnimationsModule,
            ToastrModule.forRoot({
                progressBar: true,
                progressAnimation: 'decreasing',
                positionClass: 'toast-bottom-center'
            }),
        ],
        exports: [
            CommonModule,
            ImageCropperModule,
            MaterialModule,
            FormsModule,
            ReactiveFormsModule,
            FlexLayoutModule,
            BrowserAnimationsModule,
            ImageUploaderComponent, NgImageCropperComponent, MatConfirmDialogComponent
        ]
    })
], AngularMaterialUploaderModule);

/*
 * Public API Surface of angular-material-uploader
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AlertService, AngularMaterialUploaderModule, DialogService, ImageUploaderComponent, MatConfirmDialogComponent, NgImageCropperComponent, MaterialModule as ɵa };
//# sourceMappingURL=angular-material-image-uploader.js.map
